# Pirikium
**Pirikium** is a top-down shooter game, written in lua with the [Löve 2D](https://love2d.org/) framework (version 11.1). If you need more informations, you can check the [wiki](https://github.com/Quozul/Pirikium/wiki).  

<div align="center">
    <a href="https://discord.gg/UZy8rCY"><img src="https://discordapp.com/api/guilds/472820911955902465/embed.png" alt="Discord server" title="Join our Discord server now!"/></a><br>
    E-mail me at <a href="mailto:quozul@outlook.com" alt="quozul@outlook.com" title="Send me an e-mail">quozul@outlook.com</a>
</div>

### Minimum requirements

System | Processor | Memory | Graphic card
---|---|---|---
64 bit | Dual-core @ 1GHz | 4 MB | Intel HD Graphics

## Team
* **Quôzul** <span title="Developer" width=50px>:computer:</span>
* **Katrtlen** <span title="Artist" width=50px>:pencil2:</span>

### Credits
* Some of the sounds used are from [Freesound.org](https://freesound.org/)
* [Iceland Font](https://fonts.google.com/specimen/Iceland) and [Cutive Mono Font](https://fonts.google.com/specimen/Cutive+Mono) are from Google Fonts

---

### Modules used
Here's a list of all used modules:

Use | Link | Use | Link
---|---|---|---
JSON encoder/decoder | [JSON](http://regex.info/blog/lua/json) | World generation | [Astray](https://github.com/SiENcE/astray) (not used yet)
Camara & more | [hump](https://github.com/vrld/hump/) | STI | [STI](https://github.com/karai17/Simple-Tiled-Implementation)
Serialisation | [Ser](https://github.com/gvx/Ser) & [Bitser](https://github.com/gvx/bitser) | Pathfinding | [Jumper](https://github.com/Yonaba/Jumper)
GUI | [Gspöt](https://github.com/pgimeno/Gspot) | Random names | [lua-namegen](https://github.com/LukeMS/lua-namegen)
Physics | [Box2D](https://love2d.org/wiki/love.physics) (*included in Löve2D*) | Threaded ressource loading | [love-loader](https://github.com/kikito/love-loader)
Unique IDs generator | [UUID](https://github.com/Tieske/uuid) | HTTPS requests | [LuaJIT-Request](https://github.com/LPGhatguy/luajit-request)
Lighting & shadows | [Shädows](https://github.com/matiasah/shadows)